=== debian/control ===
Source: widelands
Section: games
Priority: extra
Maintainer: Martin Quinson <mquinson@debian.org> 
Uploaders: Enrico Tassi <gareuselesinge@debian.org> 
Standards-Version: 3.9.1
Build-Depends: debhelper (>= 7.0.50~), libsdl1.2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, libsdl-net1.2-dev, libsdl-mixer1.2-dev, libsdl-gfx1.2-dev, python, libboost-dev | libboost1.35-dev, libboost-program-options-dev | libboost-program-options1.35-dev, libggz-dev, libggzmod-dev, scons (>= 1.0.1), doxygen, cmake, liblua5.1-dev, libglew1.5-dev
Vcs-Svn: svn://svn.debian.org/svn/collab-maint/deb-maint/widelands/
Vcs-Browser: http://svn.debian.org/viewsvn/collab-maint/deb-maint/widelands/
Homepage: http://www.widelands.org

Package: widelands
Architecture: any
Depends: widelands-data (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}, ttf-freefont
Description: fantasy real-time strategy game
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

Package: widelands-data
Architecture: all
Depends: ttf-freefont, ${misc:Depends}
Description: fantasy real-time strategy game (data files)
 This package contains the graphics and levels for Widelands.
 .
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

Package: widelands-dbg
Architecture: any
Section: debug
Depends: widelands (= ${binary:Version}), ${misc:Depends}
Description: fantasy real-time strategy game (debug cruft)
 This package contains the debugging symbols associated to widelands.
 .
 If you don't want to debug widelands (nor report bugs against it), you
 don't need it.
