## widelands 17

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	# "Build${WL_VERSION_MINOR}" + ".${WL_VERSION_PATCH}" if WL_VERSION_PATCH is
 	# defined.
 	set (WL_VERSION_MAJOR 0)
-	set (WL_VERSION_MINOR 15)
+	set (WL_VERSION_MINOR 17)
 
 	# Just define in case that we release patches for official builds
 	#set (WL_VERSION_PATCH 90)
@@ -107,15 +107,18 @@
 # unit_test_framework is for testing only
 if (WL_UNIT_TESTS)
   message(STATUS "Enabled unit tests")
-
+if (DEFINED MSVC)
   set (BUILD_SHARED_LIBS OFF)
-  set (Boost_FIND_COMPONENTS unit_test_framework)
-  set (Boost_USE_STATIC_LIBS   ON)
+else (DEFINED MSVC)
+  set (Boost_USE_STATIC_LIBS  OFF)
+endif (DEFINED MSVC)
+  set (Boost_FIND_COMPONENTS unit_test_framework signals)
   set (Boost_USE_MULTITHREADED ON)
   set (Boost_DETAILED_FAILURE_MSG ON)
-  find_package(Boost 1.35.0 COMPONENTS unit_test_framework REQUIRED)
+  find_package(Boost 1.35.0 COMPONENTS unit_test_framework signals REQUIRED)
 
   if (NOT DEFINED MSVC)
+  # If boost unit test library is linked dynamically, BOOST_TEST_DYN_LINK must be defined
     string( REGEX MATCH ".a$" BOOST_STATIC_UNIT_TEST_LIB ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
     if (NOT BOOST_STATIC_UNIT_TEST_LIB)
       add_definitions(-DBOOST_TEST_DYN_LINK)
@@ -132,11 +135,15 @@
   add_custom_target(autotest ALL
     COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
     WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
-    DEPENDS widelands;test_widelands_scripting
+    DEPENDS widelands;test_widelands_scripting;test_economy;test_io_filesystem
   )
 else (WL_UNIT_TESTS)
   message(STATUS "Disabled Unit Tests")
-  find_package(Boost 1.35.0 REQUIRED)
+  set (Boost_FIND_COMPONENTS signals)
+  set (Boost_USE_STATIC_LIBS   ON)
+  set (Boost_USE_MULTITHREADED ON)
+  set (Boost_DETAILED_FAILURE_MSG ON)
+  find_package(Boost 1.35.0 COMPONENTS signals REQUIRED)
 endif (WL_UNIT_TESTS)
 
 option (WL_STRICT "If strict compilation mode is requested (almost every warning is an error)" OFF)
@@ -203,8 +210,23 @@
 # CMAKE only defines "-g", but we need -DDEBUG also, and we need -DNOPARACHUTE (for SDL) in Debug
 set (CMAKE_CXX_FLAGS_DEBUG "-g -DDEBUG -DNOPARACHUTE${WL_COMPILERFLAG_OLDSTYLECAST}${WL_COMPILERFLAG_GENERICWARNINGS}${WL_COMPILERFLAG_EXTRAWARNINGS}${WL_COMPILERFLAG_STRICT}" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
 
-# CMAKE defines "-O3 -DNDEBUG", but we better say -O2 (see gcc manual)
-set (CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
+#This can be removed if no one uses gcc 4.5.1 or 4.5.2 any more
+IF (${CMAKE_COMPILER_IS_GNUCXX})
+EXEC_PROGRAM (
+    ${CMAKE_CXX_COMPILER}
+    ARGS --version
+    OUTPUT_VARIABLE WLBUILD_COMPILERVERSION
+    )
+    STRING(REGEX REPLACE ".*(4)\\.(5)\\.([0-9]).*" "\\1.\\2.\\3" WLBUILD_COMPILERVERSION_REP ${WLBUILD_COMPILERVERSION})
+    IF (WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.1" OR WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.2")
+        message("Detected gcc ${WLBUILD_COMPILERVERSION_REP}")
+        message("Suffering from gcc bug, disabling -O3")
+        set (CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
+    ELSE (WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.1" OR WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.2")
+        #This line is the default and should be preserved.
+        set (CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
+    ENDIF (WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.1" OR WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.2")
+ENDIF (${CMAKE_COMPILER_IS_GNUCXX})
 
 #If building with MSVC, then check for 3rdparty libs
 if (DEFINED MSVC)
@@ -217,28 +239,3 @@
   add_definitions( -Dstrncasecmp=_strnicmp )
   add_definitions( -Dsnprintf=_snprintf )
   add_definitions( -Drint=floor )
-  add_definitions( -Dstrtoll=_strtoi64 )
-  add_definitions( -Dstrtoull=_strtoui64 )
-  add_definitions( -DNOMINMAX -D_CRT_SECURE_NO_WARNINGS )
-  add_definitions( -Dssize_t=size_t )
-  add_definitions( -Dmkdir=_mkdir )
-  add_definitions( -DREDIRECT_OUTPUT )
-
-  # Automatic linking for boost requires setting lib dir and clearing Boost_LIBARIES
-  LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
-  set(Boost_LIBRARIES "")
-  include_directories(${Boost_INCLUDE_DIR})
-
-
-  find_library(INTL_LIBRARY NAMES intl libintl)
-
-  set (MSVC_DISABLE_WARNINGS "/wd4290 /wd4800 /wo4373 /wd4355")
-  # CMAKE only defines "-g", but we need -DDEBUG also, and we need -DNOPARACHUTE (for SDL) in Debug
-  set (CMAKE_CXX_FLAGS_DEBUG " -DDEBUG -DNOPARACHUTE /MTd /Zi /D_DEBUG ${MSVC_DISABLE_WARNINGS}" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
-
-  # CMAKE defines "-O3 -DNDEBUG", but we better say -O2 (see gcc manual)
-  set (CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG /MT /GL ${MSVC_DISABLE_WARNINGS}" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
-
-  set (CMAKE_EXE_LINKER_FLAGS_DEBUG "/debug /LTCG /NODEFAULTLIB:libcmt.lib" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
-
-else (DEFINED MSVC)
